//A very handy mutator that stores ATM info Server Side, thus saving it for future games,
//and removes potential money glitching.

class MSBankingMutator extends Mutator config(MSMTL);

var config string AccountIPs[100];
var config int AccountBalances[100];

function PostBeginPlay()
{   
 local MSBankingATM A;

	Level.Game.BaseMutator.AddMutator(Self);
	Level.Game.RegisterDamageMutator(Self);
        SetTimer(3, True);

 forEach AllActors(class'MSBankingATM', A)
 {
  if ((A != None) && (A.Bank == None))
  {
   A.Bank = Self;
   log(""$A$" has had its Banking Mutator corrected!");
  }
 } 
}

function Timer()
{
 local DeusExPlayer A;
 
 forEach AllActors(class'DeusExPlayer', A)
 {
  if ((A != None) && (A.NintendoImmunityTimeLeft > 0) && (A.Credits > 0))
  {
   A.SetPropertyText("Credits","0");
  }
 } 
}

function int GetAccountNum(string IPtoUse)
{
	local int i;

	for (i=0; i<99; i++)
		if (AccountIPs[i] ~= IPtoUse)
			return i;
        return -1;
}

function int GetAccountBalance(string stringtouse)
{
                       if (GetAccountNum(stringtouse) > -1)
			return AccountBalances[GetAccountNum(stringtouse)];
                       else if (GetAccountNum(stringtouse) == -1)
                       {
			MakeNewAccount(stringtouse);
			return 0;
		       }
}

function MakeNewAccount(string IPtoUse)
{
	local int i;

	if (GetAccountNum(IPtoUse) > -1)
	 return;
        else if (GetAccountNum(IPtoUse) == -1)

	for (i=0; i<99; i++)
		if (AccountIPs[i] ~= "")
                {
			AccountIPs[i] = IPtoUse; 
                        SaveConfig();         
                        return;
                }
}

function AddAccountBalance(string IPtoUse, int ToModBy)
{
 AccountBalances[GetAccountNum(IPtoUse)] += ToModBy;
 SaveConfig();
}

function SubAccountBalance(string IPtoUse, int ToModBy)
{
 AccountBalances[GetAccountNum(IPtoUse)] -= ToModBy;
 SaveConfig();
}

defaultproperties
{
}
